import java.awt.*;
import java.applet.*;
import java.awt.image.BufferedImage;
import java.util.Random;

public class ZitterFahrt1
  extends Applet
  implements Runnable
{

  final int FENSTERMAX_I = 400;
  final int FENSTERMAX_J = 400;

  // 0 - 0.25: nach oben
  final double P1 = 0.25;
  // 0.25 - 0.5: nach links
  final double P2 = 0.5;
  // 0.5 - 0.75: nach rechts
  final double P3 = 0.75;
  // 0.75 - 1: nach unten


  /* hauptProgramm ************************************************************
     **************************************************************************
   */

  public void hauptProgramm(Graphics bildschirm) {
    int i = FENSTERMAX_I/2;
    int j = FENSTERMAX_J/2;
    int inew;
    int jnew;
    double zz;
    for (int count=0; count<100000; count++) {
      bildschirm.drawLine(i,j,i,j);

      zz = zufallsZahl();
      if (zz<P1) {
        j--;
      }
      if (zz>=P1 && zz<P2) {
        i--;
      }
      if (zz>=P2 && zz<P3) {
        i++;
      }
      if (zz>=P3) {
        j++;
      }

      repaint();
    }
  }


  /* *******************************************************
   * Hier beginnt der kryptische Teil vom Java-Programm. Den Teil brauchst du nicht
   * zu verstehen. Sogar Profis haben Mhe, immer genau den berblick zu behalten.
   */

  public Graphics zeichnungsBrett;
  public BufferedImage zeichnungsBrettBild;
  private Thread thread;
  private boolean isRunning = false;
  private Random zufallsZahlen = new Random();

  public double zufallsZahl() {
    // gibt mit eine Zufallszahl zwischen 0 und 1 zurck
    return zufallsZahlen.nextDouble();
  }

  public boolean isPixel(int i, int j) {
    // die Farbe schwarz entspricht der Zahl -16777216
    if (i<0 || j<0 || i>=FENSTERMAX_I || j>=FENSTERMAX_J) {
      return false;
    }
    return (zeichnungsBrettBild.getRGB(i,j) == -16777216 );
  }

  public void init() {
    /* Wird zu Beginn (vom Appletviewer) aufgerufen, wenn das Applet gestartet wird.
     */
    thread = null;
    zeichnungsBrettBild = new BufferedImage(FENSTERMAX_I, FENSTERMAX_J, BufferedImage.TYPE_INT_RGB);
    for (int j=0; j<FENSTERMAX_J; j++) {
      for (int i=0; i<FENSTERMAX_I; i++) {
        zeichnungsBrettBild.setRGB(i,j,256*256*256-1);
      }
    }
    zeichnungsBrett = zeichnungsBrettBild.getGraphics();
    zeichnungsBrett.setColor(Color.black);
  }

  public void start() {
    /* Kreiert einen neuen Thread, der nur fr unser hauptProgramm zustndig ist.
     * Der "alte" Thread bleibt auch aktiv, er sorgt dafr, dass das Gezeichnete
     * wenn ntig neu dargestllt wird.
     */
    if (thread == null) {
      thread = new Thread(this);
    }
    thread.start();
  }

  public void run() {
    /* Diese Methode wird durch thread.start(); ausgelst. Sie ruft unsere
     * Methode hauptProgramm() auf und beendet den Thread anschliessend.
     */
    isRunning = true;
    hauptProgramm(zeichnungsBrett);
    isRunning = false;
  }

  public void stop() {
    /* Wenn der Appletviewer beendet wird, so soll auch der Thread, der fr das
     * Neuzeichnen zustndig ist, beendet werden.
     */
    if ( (thread != null) && thread.isAlive() ) {
      thread.interrupt();
      thread = null;
      isRunning = false;
    }
  }

  public void zeichneZeichnungsBrettAufDenBildschirm(Graphics bildschirm) {
    bildschirm.drawImage(zeichnungsBrettBild, 0, 0, null);
  }

  public void update(Graphics bildschirm) {
    /* Wird vom der Methode repaint aufgerufen.
     * Wird keine update Methode deklariert, so wird der Bildschirm weiss gezeichnet
     * und anschliessend die Methode paint aufgerufen
     */
    zeichneZeichnungsBrettAufDenBildschirm(bildschirm);
  }

  public void paint(Graphics bildschirm) {
    /* zeichnet den Bildschirm neu, wenn ein anderes Fenster vorher einen Teil
     * verdeckt hat und nun dieses Fenster sich verndert hat.
     */
    zeichneZeichnungsBrettAufDenBildschirm(bildschirm);
  }

  public void schlafe(int schlafZeit) {
    /* legt das Programm eine gewisse Zeit schlafen. Die Zahl schlafZeit gibt die
     * Dauer des Schlafens in Millisekunden an. */
    try {
      if (isRunning) {
        repaint();
        Thread.sleep(schlafZeit);
      }
    }
    catch (InterruptedException e) {
      // Exception abfangen
    }
  }

} 